# $Id: ag_i18n_inc.sh,v 2.25.2.14 2009/09/05 00:22:37 sbidaye Exp $
# $Copyrights: Copyright (c) 2011 Symantec Corporation.
# All rights reserved.
#
# THIS SOFTWARE CONTAINS CONFIDENTIAL INFORMATION AND TRADE SECRETS OF
# SYMANTEC CORPORATION.  USE, DISCLOSURE OR REPRODUCTION IS PROHIBITED
# WITHOUT THE PRIOR EXPRESS WRITTEN PERMISSION OF SYMANTEC CORPORATION.
#
# The Licensed Software and Documentation are deemed to be commercial
# computer software as defined in FAR 12.212 and subject to restricted
# rights as defined in FAR Section 52.227-19 "Commercial Computer
# Software - Restricted Rights" and DFARS 227.7202, "Rights in
# Commercial Computer Software or Commercial Computer Software
# Documentation", as applicable, and any successor regulations. Any use,
# modification, reproduction release, performance, display or disclosure
# of the Licensed Software and Documentation by the U.S. Government
# shall be solely in accordance with the terms of this Agreement.  $
#
# this file can be included using : 
#   UNIX    : . $VCS_HOME/bin/ag_i18n_inc.sh
#   WINDOWS : not supported

PATH=/usr/bin:/bin:/usr/sbin:/sbin:$PATH

ACTION_ENTRY_PT="actions"

if [ "${CLUSTER_PRODUCT}" = "VAD" ] ;  then
    CLUSTER_FQPN="Veritas Application Director"; export CLUSTER_FQPN
    VCSCONF="${VAD_CONF:-/etc/VRTSvad}"
    VCSHOME="${VAD_HOME:-/opt/VRTSvad}"
    VCSLOG="${VAD_LOG:-/var/VRTSvad}"
    HADECRYPT="${VCSHOME}/sbin/vaddecrypt"; export HADECRYPT
    HAENCRYPT="${VCSHOME}/bin/vadencrypt"; export HAENCRYPT
else
    CLUSTER_FQPN="Veritas Cluster Server"; export CLUSTER_FQPN
    VCSCONF="${VCS_CONF:-/etc/VRTSvcs}"
    VCSHOME="${VCS_HOME:-/opt/VRTSvcs}"
    VCSLOG="${VCS_LOG:-/var/VRTSvcs}"
    HADECRYPT="${VCSHOME}/sbin/vcsdecrypt"; export HADECRYPT
    HAENCRYPT="${VCSHOME}/bin/vcsencrypt"; export HAENCRYPT
fi

HAATTR="${VCSHOME}/bin/haattr"; export HAATTR
HACLUS="${VCSHOME}/bin/haclus"; export HACLUS
HAGRP="${VCSHOME}/bin/hagrp"; export HAGRP
HAIFCONFIG="${VCSHOME}/bin/haifconfig"; export HAIFCONFIG
HALOG="${VCSHOME}/bin/halog"; export HALOG
HALOGIN="${VCSHOME}/bin/halogin"; export HALOGIN
HARES="${VCSHOME}/bin/hares"; export HARES
HASTATUS="${VCSHOME}/bin/hastatus"; export HASTATUS
HASYS="${VCSHOME}/bin/hasys"; export HASYS
HATYPE="${VCSHOME}/bin/hatype"; export HATYPE
HAUSER="${VCSHOME}/bin/hauser"; export HAUSER
NOTIFIER="${VCSHOME}/bin/notifier"; export NOTIFIER

FILE_NAME=$0

# for localization
VCS_SUPPLANG="C"
VCS_USERLANG="${LANG}"
VCS_IS_CLANG_SET=1

# LogDbg
VCSAG_LOGDBG="NOT_DEFINED"

# set entry point
VCS_LOG_SCRIPT_NAME=`basename ${FILE_NAME}`

# set agent name
AGENT_DIR=`dirname ${FILE_NAME}`
VCSAG_BASE_AGENT_DIR=`basename ${AGENT_DIR}`

# special treatment to action entry point
if [ "${VCSAG_BASE_AGENT_DIR}" = "${ACTION_ENTRY_PT}" ]; then
    VCS_LOG_SCRIPT_NAME="${VCSAG_BASE_AGENT_DIR}"
    AGENT_DIR=`dirname ${AGENT_DIR}`
    VCSAG_BASE_AGENT_DIR=`basename ${AGENT_DIR}`
fi

# states of a resource
VCSAG_RES_UNKNOWN=99; export VCSAG_RES_UNKNOWN
VCSAG_RES_OFFLINE=100; export VCSAG_RES_OFFLINE
VCSAG_RES_ONLINE=110; export VCSAG_RES_ONLINE
VCSAG_RES_INTENTOFFLINE=200; export VCSAG_RES_INTENTOFFLINE
VCSAG_RES_INTENTIONALOFFLINE=${VCSAG_RES_INTENTOFFLINE};
export VCSAG_RES_INTENTIONALOFFLINE;

# return values of GET_ATTR_INDEX/VALUE
VCSAG_SUCCESS=0
VCSAG_NULL_ATTR=1
VCSAG_NULL_ARGLIST=2
VCSAG_ATTR_NOTFOUND=3
VCSAG_INVAL_ARGLIST=4
VCSAG_INVAL_INDEX=5
VCSAG_INVAL_NUMVALS=6

# set category-id
SYSTEM=`uname -s`
case ${SYSTEM} in
    AIX)
        VCS_LOG_CATEGORY=10011;;
    HP-UX)
        VCS_LOG_CATEGORY=10021;;
    Linux)
        VCS_LOG_CATEGORY=10031;;
    SunOS)
        PATH=/usr/xpg4/bin:$PATH; # for correct grep
        VCS_LOG_CATEGORY=10001;;
esac

LANG="${VCS_SUPPLANG}"; export LANG

if [ -z "${VCS_LOG_AGENT_NAME}" ]; then
    VCS_LOG_AGENT_NAME=${VCSAG_BASE_AGENT_DIR}
    export VCS_LOG_AGENT_NAME
fi

VAD_LOG_SCRIPT_NAME=${VCS_LOG_SCRIPT_NAME}
VAD_LOG_CATEGORY=${VCS_LOG_CATEGORY}
if [ -z "${VAD_LOG_AGENT_NAME}" ]; then
    VAD_LOG_AGENT_NAME=${VCS_LOG_AGENT_NAME}
    export VAD_LOG_AGENT_NAME
fi

export PATH
export VCSCONF VCSHOME VCSLOG
export VCS_LOG_SCRIPT_NAME VAD_LOG_SCRIPT_NAME
export VCS_LOG_CATEGORY VAD_LOG_CATEGORY
export VCSAG_ATTR_NOTFOUND VCSAG_INVAL_ARGLIST VCSAG_INVAL_INDEX
export VCSAG_SUCCESS VCSAG_NULL_ATTR VCSAG_NULL_ARGLIST VCSAG_INVAL_TYPE

# set the environment variables required for logging.
# this function must be called once before calling the
# logging function VCSAG_LOG_MSG/VCSAG_LOGDBG_MSG.
#
# usage:
#   0. VCSAG_SET_ENVS # only for triggers
#   1. VCSAG_SET_ENVS $resource_name [$category] [$entry_point]
VCSAG_SET_ENVS ()
{
    if [ $# -eq 0 ]; then # only for triggers
        VCS_LOG_CATEGORY=6
        VAD_LOG_CATEGORY=6
        export VCS_LOG_CATEGORY VAD_LOG_CATEGORY
        unset VCS_LOG_AGENT_NAME VAD_LOG_AGENT_NAME
        return
    fi

    VCSAG_LOGDBG="${CLUSTER_LOGDBG}"

    # resource name. passed by caller
    VCS_LOG_RESOURCE_NAME=$1; export VCS_LOG_RESOURCE_NAME
    VAD_LOG_RESOURCE_NAME=$1; export VAD_LOG_RESOURCE_NAME

    # category and/or entry point. passed by caller [optional]
    OPT_ARG1=$2; OPT_ARG2=$3

    if [ "${OPT_ARG1}" ]; then
        GREP_OUT=`echo "${OPT_ARG1}" | grep '[^0-9]'` # check for category
        if [ -z "${GREP_OUT}" ]; then
            VCS_LOG_CATEGORY=${OPT_ARG1}
            VAD_LOG_CATEGORY=${OPT_ARG1}
        else
            GREP_OUT=`echo "${OPT_ARG1}" | grep '[^a-z]'` #check for entry point
            if [ -z "${GREP_OUT}" ]; then
                VCS_LOG_SCRIPT_NAME=${OPT_ARG1}
                VAD_LOG_SCRIPT_NAME=${OPT_ARG1}
            fi
        fi
    fi

    if [ "${OPT_ARG2}" ]; then
        GREP_OUT=`echo "${OPT_ARG2}" | grep '[^0-9]'` # check for category
        if [ -z "${GREP_OUT}" ]; then
            VCS_LOG_CATEGORY=${OPT_ARG2}
            VAD_LOG_CATEGORY=${OPT_ARG2}
        else
            GREP_OUT=`echo "${OPT_ARG2}" | grep '[^a-z]'` #check for entry point
            if [ -z "${GREP_OUT}" ]; then
                VCS_LOG_SCRIPT_NAME=${OPT_ARG2}
                VAD_LOG_SCRIPT_NAME=${OPT_ARG2}
            fi
        fi
    fi
}


# reset LANG/locale to C
#
# usage:
# VCSAG_SET_LANG
VCSAG_SET_LANG ()
{
    if [ ${VCS_IS_CLANG_SET} -eq 0 ]; then
        LANG="${VCS_SUPPLANG}"; export LANG
        VCS_IS_CLANG_SET=1
    fi
}


# reset LANG/locale to user defined LANG/locale
#
# usage:
# VCSAG_RESET_LANG
VCSAG_RESET_LANG ()
{
    if [ ${VCS_IS_CLANG_SET} -eq 1 ]; then
        LANG="${VCS_USERLANG}"; export LANG
        VCS_IS_CLANG_SET=0
    fi
}


# for internal use only
#
# usage:
# VCSAG_IS_DBG_ENABLED <dbg>
#
# example:
# VCSAG_IS_DBG_ENABLED 1
VCSAG_IS_DBG_ENABLED ()
{
    dbg="$1"
    dbg_str="DBG_${dbg}"

    # VCSAG_LOGDBG is defined for agents only. take care of triggers.
    if [ "${VCSAG_LOGDBG}" = "NOT_DEFINED" ]; then
        return 1
    elif `echo "${VCSAG_LOGDBG}" | grep -w ${dbg_str} >/dev/null`; then
        return 1
    else
        return 0
    fi
}


# entry points must use this function if they need to fork a command
# using system call
#
# input params :
#   1. a string of command with arguments
#
# output params :
#   1. return value of system($command)
#
# usage:
# 1. $retval = VCSAG_SYSTEM($command);
#
VCSAG_SYSTEM ()
{
    command=$1

    [ -z "${command}" ] && return 0

    [ ${VCS_IS_CLANG_SET} -eq 1 ] && LANG="${VCS_USERLANG}"; export LANG
    sh -c "${command}"; retval=$?
    [ ${VCS_IS_CLANG_SET} -eq 1 ] && LANG="${VCS_SUPPLANG}"; export LANG

    return ${retval}
}


# entry points must use this function if they need to run a command in a
# differnet user's context
#
# input params :
#   1. user name
#   2. a string of su options (if the string is space seperated then
#      needs quoted string)
#   3. a string of command with arguments
#
# output params :
#   1. return value of system($command)
#
# usage:
# 1. VCSAG_SU "$user" "$command"; echo $?
#
VCSAG_SU ()
{
    user="$1"
    options="$2"
    command="$3"

    [ -z "${user}" -o -z "${command}" ] && return 0

    [ ${VCS_IS_CLANG_SET} -eq 1 ] && LANG="${VCS_USERLANG}"; export LANG
    su ${options} "${user}" -c "${command}"; retval=$?
    [ ${VCS_IS_CLANG_SET} -eq 1 ] && LANG="${VCS_SUPPLANG}"; export LANG

    return ${retval}
}


# sets timeout of the resource's entry point.
# avoid use of this function.
#
# input params :
#   1. timeout value
#
# output params : none
#
# usage:
# 1. VCSAG_SET_RES_EP_TIMEOUT <timeout>
#
# example:
# 1. VCSAG_SET_RES_EP_TIMEOUT 130
#
VCSAG_SET_RES_EP_TIMEOUT ()
{
    timeout=$1
    timeout_file="${VCSLOG}/log/tmp/.${VCS_LOG_RESOURCE_NAME}.tmo";

    echo ${timeout} > "${timeout_file}"
}


# all shell entry points must use this function if it is not a debug msg.
#
# usage:
# 1. VCSAG_LOG_MSG "<sev>" "<msg>" <msgid>
# 2. VCSAG_LOG_MSG "<sev>" "<msg>" <msgid> "$param1"
# 3. VCSAG_LOG_MSG "<sev>" "<msg>" <msgid> "-encoding <encoding>"
# 4. VCSAG_LOG_MSG "<sev>" "<msg>" <msgid> "-encoding <encoding>" "$param1"
#
# example:
# 1. VCSAG_LOG_MSG "N" "a test message" 1
# 2. VCSAG_LOG_MSG "N" "a test message of $test" 1 "$test"
# 3. VCSAG_LOG_MSG "N" "a test message" 1 "-encoding utf8"
# 4. VCSAG_LOG_MSG "N" "a test message of $test" 1 "-encoding utf8" "$test"
VCSAG_LOG_MSG ()
{
    severity="$1"
    msg="$2"
    msgid="$3"
    parameters=""
    encoding=""
    numargs=$#
    firstchar=""

    i=3
    while [ ${i} -lt ${numargs} ]; do
        i=`expr ${i} + 1`

        temp_arg="echo \${${i}}"
        next_arg=`eval ${temp_arg}`

        # if the first parameter is "-encoding <encoding>", do not concatenate
        # it in 'parameters'
        if [ ${i} -eq 4 ]; then
            encoding=`echo ${next_arg} | grep -e '^-encoding '`

            if [ "${encoding}" ]; then
                continue
            fi
        fi

        firstchar=`echo ${next_arg} | cut -b1`
        if [ "${firstchar}" = "-" ]; then
            next_arg="%${next_arg}"
        fi

        parameters="${parameters} \"${next_arg}\""
    done

    if [ "${parameters}" ]; then
        parameters="-parameters ${parameters}"
    fi

    [ ${VCS_IS_CLANG_SET} -eq 1 ] && LANG="${VCS_USERLANG}"; export LANG
    sh -c "${HALOG} -add \"${msg}\" -sev ${severity} -msgid ${msgid} ${encoding} ${parameters}"
    [ ${VCS_IS_CLANG_SET} -eq 1 ] && LANG="${VCS_SUPPLANG}"; export LANG
}


# all shell entry points must use this function if it is a debug msg.
#
# usage:
# 1. VCSAG_LOGDBG_MSG <dbg> "<msg>"
# 2. VCSAG_LOGDBG_MSG <dbg> "<msg>" <msgid>
# 3. VCSAG_LOGDBG_MSG <dbg> "<msg>" <msgid> "$param1"
# 4. VCSAG_LOGDBG_MSG <dbg> "<msg>" <msgid> "-encoding <encoding>"
# 5. VCSAG_LOGDBG_MSG <dbg> "<msg>" <msgid> "-encoding <encoding>" "$param1"
#
# example:
# 1. VCSAG_LOGDBG_MSG 1 "a test message"
# 2. VCSAG_LOGDBG_MSG 1 "a test message" 1
# 3. VCSAG_LOGDBG_MSG 1 "a test message of $test" 1 "$test"
# 4. VCSAG_LOGDBG_MSG 1 "a test message" 1 "-encoding utf8"
# 5. VCSAG_LOGDBG_MSG 1 "a test message of $test" 1 "-encoding utf8" "$test"
VCSAG_LOGDBG_MSG ()
{
    dbg="$1"
    msg="$2"
    msgid="$3"
    parameters=""
    encoding=""
    numargs=$#
    firstchar=""

    VCSAG_IS_DBG_ENABLED ${dbg}; VCSAG_RETVAL=$?
    if [ ${VCSAG_RETVAL} -eq 0 ]; then
        return 0
    fi

    # if msgid is not passed.
    if [ -z "${msgid}" ]; then
        [ ${VCS_IS_CLANG_SET} -eq 1 ] && LANG="${VCS_USERLANG}"; export LANG
        ${HALOG} -add "${msg}" -dbg ${dbg}
        [ ${VCS_IS_CLANG_SET} -eq 1 ] && LANG="${VCS_SUPPLANG}"; export LANG
        return 0
    fi

    i=3
    while [ ${i} -lt ${numargs} ]; do
        i=`expr ${i} + 1`

        temp_arg="echo \${${i}}"
        next_arg=`eval ${temp_arg}`

        # if the first parameter is "-encoding <encoding>", do not concatenate
        # it in 'parameters'
        if [ ${i} -eq 4 ]; then
            encoding=`echo ${next_arg} | grep -e '^-encoding '`

            if [ "${encoding}" ]; then
                continue
            fi
        fi

        firstchar=`echo ${next_arg} | cut -b1`
        if [ "${firstchar}" = "-" ]; then
            next_arg="%${next_arg}"
        fi

        parameters="${parameters} \"${next_arg}\""
    done

    if [ "${parameters}" ]; then
        parameters="-parameters ${parameters}"
    fi

    [ ${VCS_IS_CLANG_SET} -eq 1 ] && LANG="${VCS_USERLANG}"; export LANG
    sh -c "${HALOG} -add \"${msg}\" -dbg ${dbg} -msgid ${msgid} ${encoding} ${parameters}"
    [ ${VCS_IS_CLANG_SET} -eq 1 ] && LANG="${VCS_SUPPLANG}"; export LANG
}


# returns value of a given attribute
#
# input params :
#   1. attribute name
#   2. index of attribute (optional). value starts from 0.
#   3. arglist [should start from attibutes. ResourceName and
#               CleanReason should not be passed]
#
# output params :
#   1. returns VCSAG_SUCCESS when successful
#   2. sets VCSAG_ATTR_INDEX as index of attribute if success
#
VCSAG_GET_ATTR_INDEX ()
{
    index_i=0
    index_tmp_i=0
    index_attr=""
    index_index_of_attr="-1"

    INDEX_GREP_OUT=""

    VCSAG_ATTR_INDEX="-1"; export VCSAG_ATTR_INDEX

    case $# in
        0) 
            VCSAG_PRINT_ERROR ${VCSAG_NULL_ATTR};
            return ${VCSAG_NULL_ATTR};;
        1)
            VCSAG_PRINT_ERROR ${VCSAG_NULL_ARGLIST} $1;
            return ${VCSAG_NULL_ARGLIST};;
    esac

    index_attr=`echo $1`; shift

    INDEX_GREP_OUT=`echo $1 | grep '[^0-9]'`
    if [ "$1" = "-1" -o -z "${INDEX_GREP_OUT}" ]; then
        index_index_of_attr=$1; shift
    fi

    if [ $# -eq 0 ]; then
        VCSAG_PRINT_ERROR ${VCSAG_NULL_ARGLIST} ${index_attr}
        return ${VCSAG_NULL_ARGLIST}
    fi

    # arglist in $@ starts from index 1 and we are taking input 0 as
    # first argument
    index_index_of_attr=`expr ${index_index_of_attr} + 1`

    # sh on solaris does not work for ${10}, so check for -le 9
    if [ ${index_index_of_attr} -gt 0 -a \
         ${index_index_of_attr} -le $# -a \
         ${index_index_of_attr} -le 9 ]; then
        if [ "${index_attr}" = "`eval echo \\${${index_index_of_attr}}`" ]; then
            VCSAG_ATTR_INDEX=`expr ${index_index_of_attr} - 1`; export VCSAG_ATTR_INDEX
            return ${VCSAG_SUCCESS}
        fi
    fi

    # in every loop $1 is attribute name and $2 is number of elements
    index_i=0
    while [ $# -gt 0 ]; do
        if [ "${index_attr}" = "$1" ]; then
            VCSAG_ATTR_INDEX=${index_i}; export VCSAG_ATTR_INDEX
            return ${VCSAG_SUCCESS}
        fi

        if [ $# -lt 2 ]; then
            VCSAG_PRINT_ERROR ${VCSAG_INVAL_ARGLIST} ${index_attr}
            return ${VCSAG_INVAL_ARGLIST}
        fi

        INDEX_GREP_OUT=`echo $2 | grep '[^0-9]'`
        if [ "${INDEX_GREP_OUT}" ]; then
            VCSAG_PRINT_ERROR ${VCSAG_INVAL_NUMVALS} ${index_attr} $2
            return ${VCSAG_INVAL_NUMVALS}
        fi

        index_tmp_i=`expr $2 + 2`
        if [ ${index_tmp_i} -gt $# ]; then
            VCSAG_PRINT_ERROR ${VCSAG_INVAL_ARGLIST} ${index_attr}
            return ${VCSAG_INVAL_ARGLIST}
        fi

        shift ${index_tmp_i}

        index_i=`expr ${index_i} + ${index_tmp_i}`
    done 

    VCSAG_PRINT_ERROR ${VCSAG_ATTR_NOTFOUND} "${index_attr}"
    return ${VCSAG_ATTR_NOTFOUND}
}


# returns value of a given attribute
#
# input params :
#   1. attribute name
#   2. index of attribute (optional). value starts from 0.
#   3. index of value required (optional. must be passed alongwith
#      index of attribute) value starts from 1. if index of attribute
#      is not known but index of value is know then pass -1 as
#      index of attribute.
#   4. arglist [should start from attributes. ResourceName and
#               CleanReason should not be passed]
#
# output params :
#   1. returns VCSAG_SUCCESS when successful
#   2. sets VCSAG_ATTR_VALUE as value of attribute if success
#   3. sets VCSAG_ATTR_INDEX as index of attribute if success
#
VCSAG_GET_ATTR_VALUE ()
{
    value_attr=""
    value_index_of_attr="-1"
    value_index_of_val=0
    arg_index_of_val=0

    VALUE_GREP_OUT=""

    VCSAG_ATTR_VALUE="0"; export VCSAG_ATTR_VALUE

    case $# in
        0) 
            VCSAG_PRINT_ERROR ${VCSAG_NULL_ATTR};
            return ${VCSAG_NULL_ATTR};;
        1)
            VCSAG_PRINT_ERROR ${VCSAG_NULL_ARGLIST} $1;
            return ${VCSAG_NULL_ARGLIST};;
    esac

    value_attr=`echo $1`; shift

    value_index_of_attr="-1"
    VALUE_GREP_OUT=`echo $1 | grep '[^0-9]'`
    if [ "$1" = "-1" -o -z "${VALUE_GREP_OUT}" ]; then
        value_index_of_attr=$1; shift
    fi

    if [ $# -eq 0 ]; then
        VCSAG_PRINT_ERROR ${VCSAG_NULL_ARGLIST} ${value_attr}
        return ${VCSAG_NULL_ARGLIST}
    fi

    VALUE_GREP_OUT=`echo $1 | grep '[^0-9]'`
    if [ "$1" = "-1" -o -z "${VALUE_GREP_OUT}" ]; then
        value_index_of_val=$1; shift
    fi

    if [ $# -eq 0 ]; then
        VCSAG_PRINT_ERROR ${VCSAG_NULL_ARGLIST} ${value_attr}
        return ${VCSAG_NULL_ARGLIST}
    fi

    VCSAG_GET_ATTR_INDEX ${value_attr} ${value_index_of_attr} "$@"
    VCSAG_RETVAL=$?
    if [ ${VCSAG_RETVAL} -ne ${VCSAG_SUCCESS} ]; then
        return ${VCSAG_RETVAL}
    fi

    shift ${VCSAG_ATTR_INDEX}; shift

    # $1 is now pointing to number of elements
    if [ $# -lt 1 ]; then
        VCSAG_PRINT_ERROR ${VCSAG_INVAL_ARGLIST} ${value_attr}
        return ${VCSAG_INVAL_ARGLIST}
    fi

    VALUE_GREP_OUT=`echo $1 | grep '[^0-9]'`
    if [ "${VALUE_GREP_OUT}" ]; then
        VCSAG_PRINT_ERROR ${VCSAG_INVAL_NUMVALS} ${value_attr} $1
        return ${VCSAG_INVAL_NUMVALS}
    fi

    if [ ${value_index_of_val} -lt 1 ]; then
        VCSAG_ATTR_VALUE="$1"; export VCSAG_ATTR_VALUE
        return ${VCSAG_SUCCESS}
    fi

    if [ ${value_index_of_val} -gt $1 ]; then
        VCSAG_PRINT_ERROR ${VCSAG_INVAL_INDEX} ${value_attr} ${value_index_of_val} $1
        return ${VCSAG_INVAL_INDEX}
    fi

    arg_index_of_val=`expr ${value_index_of_val} + 1`
    if [ ${arg_index_of_val} -gt $# ]; then
        VCSAG_PRINT_ERROR ${VCSAG_INVAL_ARGLIST} ${value_attr}
        return ${VCSAG_INVAL_ARGLIST}
    fi

    shift ${value_index_of_val}

    # $1 is now the actual value
    VCSAG_ATTR_VALUE=$1 ; export VCSAG_ATTR_VALUE
    return ${VCSAG_SUCCESS}
}


# print debug message for a given error id
#
VCSAG_PRINT_ERROR ()
{
    print_error_id=$1
    print_attr=$2
    print_arg1=$3
    print_arg2=$4
    error_string=""

    if [ ${print_error_id} -eq ${VCSAG_NULL_ATTR} ]; then
        error_string="Attribute argument is pointing to NULL."
    elif [ ${print_error_id} -eq ${VCSAG_NULL_ARGLIST} ]; then
        error_string="Attribute:${print_attr}:Argument list is pointing to NULL."
    elif [ ${print_error_id} -eq ${VCSAG_ATTR_NOTFOUND} ]; then
        error_string="Attribute ${print_attr} not found in the argument list."
    elif [ ${print_error_id} -eq ${VCSAG_INVAL_ARGLIST} ]; then
        error_string="Attribute:${print_attr}:Argument list is not valid."
    elif [ ${print_error_id} -eq ${VCSAG_INVAL_INDEX} ]; then
        error_string="Attribute:${print_attr}:Index ${print_arg1} is not valid. Total number of elements is ${print_arg2}."
    elif [ ${print_error_id} -eq ${VCSAG_INVAL_NUMVALS} ]; then
        error_string="Attribute:${print_attr}:Number of elements ${print_arg1} is not a number."
    elif [ ${print_error_id} -ne ${VCSAG_SUCCESS} ]; then
        error_string="Unknown error id:${print_error_id}."
    fi

    if [ "${error_string}" ]; then
        VCSAG_LOGDBG_MSG 1 "${error_string}"
    fi
}
