
package vcs_net_utils_inc;

use Exporter;
@ISA = ('Exporter');

our @EXPORT = qw(VCSNetGetIPVersion VCSNetGetCompressedIP VCSNetGetUncompressedIP);

use Net::IP ':PROC';
use File::Basename;
use POSIX qw(uname);
use strict;



my ($PATH) = $ENV{PATH};
$PATH = "/usr/bin:/bin:/usr/sbin:/sbin:$PATH";
$ENV{PATH} = $PATH;


# determine whether IP address is v6 or v4
# parameter: ip address
# Returns: 4 = ipv4 address
#          6 = ipv6 address
#          -1 = invalid address
  
sub VCSNetGetIPVersion {
	my $address = shift;
	if (ip_is_ipv4($address)) {
		return 4;
	}
	elsif (ip_is_ipv6($address)) {
		return 6;
	}
	else {
		return -1;
	}
}

# Compress a valid IPv6/v4 address
# parameter: ip address
# Returns: compressed IPv6 address
#	   IPv4 address as it is for IPv4 addresses 
#	   undef on error (invalid IP address)
#
#	


sub VCSNetGetCompressedIP {
	my $address = shift;
	my $version = VCSNetGetIPVersion($address);

	if ($version != -1) {
		return ip_compress_address($address, $version);
	}
	else {
		return;
	}
} 

# Uncompress a valid IPv6/v4 address
# parameter: ip address
# Returns: Uncompressed IPv6 address
#          IPv4 address as it is for IPv4 addresses
#          undef on error (invalid IP address)
#
#



sub VCSNetGetUncompressedIP {
	my $address = shift;
	my $version = VCSNetGetIPVersion($address);

	if ($version != -1) {
                return ip_expand_address($address, $version);
        }
        else {
                return;
        }
}

1;







1;
